%INCLUDE "WIN32N.INC"
%INCLUDE "COMHOOKS.NH"

EXTERN _Beep@8
EXTERN _CoGetMalloc@8
EXTERN _SHGetMalloc@4
%IFNDEF CH_STATIC_LINKING
EXTERN _GetModuleHandleA@4
EXTERN _GetProcAddress@8
%ENDIF

SEGMENT .text

 ALIGN 4
 pvCoGetMalloc     DD 0
 CoGetMallocResult DD 0
 GetCoGetMalloc:
   MOV   EDX, [ESP+4]
   MOV   ECX, pvCoGetMalloc
   MOV   EAX, CoGetMallocResult
   MOV   [EDX], ECX
   RET   4

 ALIGN 4
 pvSHGetMalloc     DD 0
 SHGetMallocResult DD 0
 GetSHGetMalloc:
   MOV   EDX, [ESP+4]
   MOV   ECX, [pvSHGetMalloc]
   MOV   EAX, [SHGetMallocResult]
   MOV   [EDX], ECX
   RET   4
;-----------

  ALIGN   4
                         ;25336920-03F9-11CF-8FD0-00AA00686F13
  _CLSIDHTMLDoc40:
     ISTRUC CLSID
     AT Data1, DD 025336920H
     AT Data2, DW 03F9H
     AT Data3, DW 11CFH
     AT Data4, DB 8FH,0D0H, 00,0AAH,00,68H,6FH,13H
     IEND
  CLSIDHTMLDoc40         DD _CLSIDHTMLDoc40, TERM_CLSID
;-----------
  _IIDShellLinkA:
     ISTRUC  IID
     AT Data1, DD 0000214EEH
     AT Data2, DW 0
     AT Data3, DW 0
     AT Data4, DB 0C0H,0, 0,0,0,0,0,46H
     IEND
  IIDShellLinkA          DD _IIDShellLinkA, TERM_IID
;-----------
  _IIDClassFactory:
     ISTRUC  IID
     AT Data1, DD 000000001H
     AT Data2, DW 0
     AT Data3, DW 0
     AT Data4, DB 0C0H,0, 0,0,0,0,0,46H  ;also in ole?.lib
     IEND
  IIDClassFactory        DD _IIDClassFactory, TERM_IID
;-----------
  _IIDDispatch:
     ISTRUC  IID
     AT Data1, DD 000020400H
     AT Data2, DW 0
     AT Data3, DW 0
     AT Data4, DB 0C0H,0, 0,0,0,0,0,46H
     IEND
  IIDDispatch            DD _IIDDispatch, TERM_IID
;-----------

 NewCoGetMallocMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 04
   AT  NewMethod, DD NewCoGetMallocRealloc
   IEND
   TERM_METHOD_HOOK

 NewSHGetMallocMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 04
   AT  NewMethod, DD NewSHGetMallocRealloc
   IEND
   TERM_METHOD_HOOK

 NewUnknownMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 00
   AT  NewMethod, DD NewUnknownQueryInterface
   IEND
   TERM_METHOD_HOOK

 NewClassFactoryMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 03
   AT  NewMethod, DD NewClassFactoryCreateInstance
   IEND
   TERM_METHOD_HOOK

 NewDispatchMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 06
   AT  NewMethod, DD NewDispatchInvoke
   IEND
   TERM_METHOD_HOOK

 NewShellLinkAMethods:
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 07
   AT  NewMethod, DD NewShellLinkASetDescription
   IEND
   ISTRUC   METHOD_HOOK
   AT  MethodNo,  DD 20
   AT  NewMethod, DD NewShellLinkASetPath
   IEND
   TERM_METHOD_HOOK
;-----------------------

BeginComHooks Test0
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CONST_INTERFACE
   AT  CLSIDs,      DD GetSHGetMalloc
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD ALL_INTERFACES
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 09
   AT  MethodHooks, DD NewSHGetMallocMethods
   AT  lpUserData,  DD 0
   IEND
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CONST_INTERFACE
   AT  CLSIDs,      DD GetCoGetMalloc
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD ALL_INTERFACES
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 09
   AT  MethodHooks, DD NewCoGetMallocMethods
   AT  lpUserData,  DD 0
   IEND
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CLASS_INTERFACE
   AT  CLSIDs,      DD ALL_CLASSES
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD ALL_INTERFACES
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 03
   AT  MethodHooks, DD NewUnknownMethods
   AT  lpUserData,  DD 0
   IEND
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CLASS_INTERFACE
   AT  CLSIDs,      DD ALL_CLASSES
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD IIDClassFactory
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 05
   AT  MethodHooks, DD NewClassFactoryMethods
   AT  lpUserData,  DD 0
   IEND
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CLASS_INTERFACE
   AT  CLSIDs,      DD CLSIDHTMLDoc40
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD IIDDispatch
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 07
   AT  MethodHooks, DD NewDispatchMethods
   AT  lpUserData,  DD 0
   IEND
   ISTRUC           COM_HOOK
   AT  dwFlags,     DD CLASS_INTERFACE
   AT  CLSIDs,      DD ALL_CLASSES
   AT  xCLSIDs,     DD NO_CLASSES
   AT  IIDs,        DD IIDShellLinkA
   AT  xIIDs,       DD NO_INTERFACES
   AT  NumMethods,  DD 21
   AT  MethodHooks, DD NewShellLinkAMethods
   AT  lpUserData,  DD 0
   IEND
EndComHooks


%DEFINE pCHInfo [EBP+16]
%DEFINE This_   [EBP+20]
 NewUnknownQueryInterface: ;ReqPar1, ReqPar2, pCHInfo, This_, riid, ppv
%DEFINE riid    DWORD [EBP+24]
%DEFINE ppv     DWORD [EBP+28]
   PUSH    EBP
   MOV     EBP, ESP

   PUSH    BYTE 100   
   PUSH    BYTE 100   
   CALL    _Beep@8

   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, [EAX+CHINFO.CHApis]
   PUSH    BYTE 3 
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   TEST    EAX, EAX
   JNE     Failed

;----test
   MOV     ECX, ppv
   MOV     EAX, pCHInfo
   MOV     EAX, [EAX+CHINFO.CHApis]
   PUSH    DWORD [ECX]
   PUSH    riid
   CALL    [EAX+COM_HOOK_APIS.GetNumMethods]
   MOV     EAX, pCHInfo
   MOV     ECX, [EAX+CHINFO.OldMethod]
   MOV     EAX, [EAX+CHINFO.CHApis]
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.GetMethodAddr]
;----

   MOV     EAX, ppv
   MOV     ECX, This_
   CMP     [EAX], ECX
   JE      Done
   MOV     EAX, pCHInfo
   MOV     EDX, [EAX+CHINFO.CHApis]
   LEA     ECX, [EAX+CHINFO.mCLSID]
   PUSH    BYTE ALL_COM_HOOKS
   PUSH    DWORD [EAX+CHINFO.ComHookChain]
   PUSH    ppv
   PUSH    riid
   PUSH    ECX
   CALL    [EDX+COM_HOOK_APIS.HookMethods]
  Done:
   SUB     EAX, EAX
  Failed:
   LEAVE
   RET     4*6
%UNDEF riid
%UNDEF ppv

 NewCoGetMallocRealloc: ;ReqPar1, ReqPar2, pCHInfo, This_, pv, cb_
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 200   
   CALL    _Beep@8 
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   PUSH    BYTE 3
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   LEAVE
   RET     4*6

 NewSHGetMallocRealloc: ;ReqPar1, ReqPar2, pCHInfo, This_, pv, cb_
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 300   
   CALL    _Beep@8 
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   PUSH    BYTE 3
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   LEAVE
   RET     4*6

 NewClassFactoryCreateInstance: ;ReqPar1, ReqPar2, pCHInfo, This_, pUnkOuter, riid, ppv
%DEFINE riid    DWORD[EBP+28]
%DEFINE ppv     DWORD[EBP+32]
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 400   
   CALL    _Beep@8
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EDX, [EAX+CHINFO.CHApis]
   PUSH    BYTE 4
   PUSH    ECX
   CALL    [EDX+COM_HOOK_APIS.CallOldMethod]
   TEST    EAX, EAX
   JNE     Failed_
   MOV     EAX, pCHInfo
   MOV     EDX, [EAX+CHINFO.CHApis]
   LEA     ECX, [EAX+CHINFO.mCLSID]
   PUSH    BYTE ALL_COM_HOOKS
   PUSH    DWORD [EAX+CHINFO.ComHookChain]
   PUSH    ppv
   PUSH    riid
   PUSH    ECX
   CALL    [EDX+COM_HOOK_APIS.HookMethods]
   SUB     EAX, EAX
  Failed_:
   LEAVE
   RET     4*7
%UNDEF riid
%UNDEF ppv

 NewDispatchInvoke: ;ReqPar1, ReqPar2, pCHInfo,\
          ;This_,dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 500   
   CALL    _Beep@8
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   PUSH    BYTE 9
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   LEAVE
   RET     4*12

 NewShellLinkASetDescription: ;ReqPar1, ReqPar2, pCHInfo, This_, pszName
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 600   
   CALL    _Beep@8
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   PUSH    BYTE 2
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   LEAVE
   RET     4*5

 NewShellLinkASetPath: ;ReqPar1, ReqPar2, pCHInfo, This_, pszFile
   PUSH    EBP
   MOV     EBP, ESP
   PUSH    BYTE 100   
   PUSH    DWORD 700   
   CALL    _Beep@8
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, [EAX+CHINFO.CHApis]
   PUSH    BYTE 2
   PUSH    ECX
   CALL    [EAX+COM_HOOK_APIS.CallOldMethod]
   LEAVE
   RET     4*5
;------------------------------------------------------

%IFNDEF CH_STATIC_LINKING
  CHServer             CHServerName
  RegisterComHookChain CHRegisterName
%ENDIF

GLOBAL _DllMain@12
_DllMain@12:

  MOV      AL, [ESP+8]
  CMP      AL, DLL_PROCESS_ATTACH
  JNE      Ignore

  PUSH     BYTE NULL
  PUSH     ESP
  CALL     _SHGetMalloc@4
  POP      DWORD [pvSHGetMalloc]
  MOV      [SHGetMallocResult], EAX

  PUSH     BYTE NULL
  PUSH     ESP
  PUSH     BYTE 1
  CALL     _CoGetMalloc@8
  POP      DWORD [pvCoGetMalloc]
  MOV      [CoGetMallocResult], EAX

%IFDEF CH_STATIC_LINKING
  MOV      EAX, RegisterComHookChain
%ELSE
  PUSH     DWORD CHServer
  CALL     _GetModuleHandleA@4
  TEST     EAX, EAX
  JE       Failure
  PUSH     DWORD RegisterComHookChain
  PUSH     EAX
  CALL     _GetProcAddress@8
  TEST     EAX, EAX
  JE       Failure
%ENDIF
  PUSH     DWORD Test0 
  CALL     EAX
 Ignore:
 Failure:
  RET      12
END