library Test0;
{$IMAGEBASE $56880000}
uses Windows, ComHooks, Ole2, ActiveX, ShlObj;

// for CONST_INTERFACE:---------------------------------
var
pvCoGetMalloc     : Pointer = nil;
pvSHGetMalloc     : Pointer = nil;
CoGetMallocResult : HRESULT;
SHGetMallocResult : HRESULT;

function GetSHGetMalloc(var ppv : Pointer):HRESULT; stdcall;
begin
   ppv := pvSHGetMalloc;
   GetSHGetMalloc := SHGetMallocResult;
end;

function GetCoGetMalloc(var ppv : Pointer):HRESULT; stdcall;
begin
   ppv := pvCoGetMalloc;
   GetCoGetMalloc := CoGetMallocResult;
end;

// NewMethods:---------------------------------
function NewQueryInterface(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; riid : LPCIID; var ppvObj : Pointer) : HRESULT; stdcall;
var QIResult : HRESULT;
begin
  Beep(100, 100); 
  QIResult := lpCHInfo^.CHApis^.CallOldMethod(@This, 3); //Ignore high part of returned DWORDLONG
  if (QIResult = S_OK) and (This <> ppvObj) then
    lpCHInfo^.CHApis^.HookMethods(@lpCHInfo^.mCLSID, riid, @ppvObj, lpCHInfo^.ComHookChain, ALL_COM_HOOKS);
  NewQueryInterface := QIResult;
end;

function NewCoGetMallocRealloc(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; pv : Pointer; cb : LongWord) : HRESULT; stdcall;
begin
  Beep(200, 100); 
  NewCoGetMallocRealloc := lpCHInfo^.CHApis^.CallOldMethod(@This, 3);
end;

function NewSHGetMallocRealloc(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; pv : Pointer; cb : LongWord) : HRESULT; stdcall;
begin
  Beep(300, 100); 
  NewSHGetMallocRealloc := lpCHInfo^.CHApis^.CallOldMethod(@This, 3);
end;

function NewClassFactoryCreateInstance(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; pUnkOuter : Pointer; riid : LPCIID; var ppvObj : Pointer) : HRESULT; stdcall;
var CFCIResult : HRESULT;
begin
  Beep(400, 100); 
  CFCIResult := lpCHInfo^.CHApis^.CallOldMethod(@This, 4); //Ignore high part of returned DWORDLONG
  if CFCIResult = S_OK then
    lpCHInfo^.CHApis^.HookMethods(@lpCHInfo^.mCLSID, riid, @ppvObj, lpCHInfo^.ComHookChain, ALL_COM_HOOKS);
  NewClassFactoryCreateInstance := CFCIResult;
end;

function NewDispatchInvoke(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; dispIdMember : LongWord; riid : LPIID; lcid :Pointer; wFlags : LongWord; pDispParams : Pointer; pVarResult: Pointer; pExcepInfo : Pointer; puArgErr : Pointer) : HRESULT; stdcall;
begin
  Beep(500, 100); 
  NewDispatchInvoke := lpCHInfo^.CHApis^.CallOldMethod(@This, 9);
end;

function NewShellLinkASetDescription(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; pszName : Pointer) : HRESULT; stdcall;
begin
  Beep(600, 100); 
  NewShellLinkASetDescription := lpCHInfo^.CHApis^.CallOldMethod(@This, 2);
end;

function NewShellLinkASetPath(ReqPar1 : LongWord; ReqPar2 : LongWord; lpCHInfo : LPCHINFO; This : Pointer; pszFile : Pointer) : HRESULT; stdcall;
begin
  Beep(700, 100); 
  NewShellLinkASetPath := lpCHInfo^.CHApis^.CallOldMethod(@This, 2);
end;

// Method Hooks:---------------------------------
const IUnknownMH      : array[0..1] of METHOD_HOOK = (
  (MethodNo:00; NewMethod:@NewQueryInterface),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK
);

const SHGetMallocMH   : array[0..1] of METHOD_HOOK = (
  (MethodNo:04; NewMethod:@NewSHGetMallocRealloc),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK  
);

const CoGetMallocMH   : array[0..1] of METHOD_HOOK = (
  (MethodNo:04; NewMethod:@NewCoGetMallocRealloc),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK  
);

const IClassFactoryMH : array[0..1] of METHOD_HOOK = (
  (MethodNo:03; NewMethod:@NewClassFactoryCreateInstance),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK  
);

const IDispatchMH     : array[0..1] of METHOD_HOOK = (
  (MethodNo:06; NewMethod:@NewDispatchInvoke),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK  
);

const IShellLinkAMH   : array[0..2] of METHOD_HOOK = (
  (MethodNo:07; NewMethod:@NewShellLinkASetDescription),
  (MethodNo:20; NewMethod:@NewShellLinkASetPath),
  (MethodNo:00; NewMethod:nil)  // TERM_METHOD_HOOK
);

// CLSID defs:---------------------------------
const CLSID_HTMLDoc40 : CLSID = (Data1:$025336920; Data2:$03F9; Data3:$11CF; Data4:($08F,$0D0, $000,$0AA,$000,$068,$06F,$013));

// CLSIDs:---------------------------------
const CLSIDHTMLDoc40  : array[0..1] of LPCLSID = (
  @CLSID_HTMLDoc40,
  TERM_CLSID
);

// IID defs:---------------------------------
//const IID_IShellLinkA : IID   = (Data1:$0000214EE; Data2:$0000; Data3:$0000; Data4:($0C0,$000, $000,$000,$000,$000,$000,$046));

// IIDs:---------------------------------
const IClassFactoryID : array[0..1] of LPIID = (
  @IID_IClassFactory, // Delphi2\Ole2.dcu
  TERM_IID
);

const IDispatchID     : array[0..1] of LPIID = (
  @IID_IDispatch,    // Delphi2\Ole2.dcu
  TERM_IID
);

const IShellLinkAID   : array[0..1] of LPIID = (
  @IID_IShellLinkA,  // ShlObj.dcu
  TERM_IID
);

// COM_HOOKs:---------------------------------
const CTest0          : array[0..6] of COM_HOOK = (
  (dwFlags:CONST_INTERFACE; CLSIDs:@GetSHGetMalloc; xCLSIDs:NO_CLASSES; IIDs:ALL_INTERFACES;   xIIDs:NO_INTERFACES; NumMethods:09; MethodHooks:@SHGetMallocMH;   lpUserData:nil),
  (dwFlags:CONST_INTERFACE; CLSIDs:@GetCoGetMalloc; xCLSIDs:NO_CLASSES; IIDs:ALL_INTERFACES;   xIIDs:NO_INTERFACES; NumMethods:09; MethodHooks:@CoGetMallocMH;   lpUserData:nil),
  (dwFlags:CLASS_INTERFACE; CLSIDs:ALL_CLASSES;     xCLSIDs:NO_CLASSES; IIDs:ALL_INTERFACES;   xIIDs:NO_INTERFACES; NumMethods:03; MethodHooks:@IUnknownMH;      lpUserData:nil),
  (dwFlags:CLASS_INTERFACE; CLSIDs:ALL_CLASSES;     xCLSIDs:NO_CLASSES; IIDs:@IClassFactoryID; xIIDs:NO_INTERFACES; NumMethods:05; MethodHooks:@IClassFactoryMH; lpUserData:nil),
  (dwFlags:CLASS_INTERFACE; CLSIDs:@CLSIDHTMLDoc40; xCLSIDs:NO_CLASSES; IIDs:@IDispatchID;     xIIDs:NO_INTERFACES; NumMethods:07; MethodHooks:@IDispatchMH;     lpUserData:nil),
  (dwFlags:CLASS_INTERFACE; CLSIDs:ALL_CLASSES;     xCLSIDs:NO_CLASSES; IIDs:@IShellLinkAID;   xIIDs:NO_INTERFACES; NumMethods:21; MethodHooks:@IShellLinkAMH;   lpUserData:nil),
  (dwFlags:COM_HOOKS_END)  // TERM_COM_HOOK
);


// Initialization:---------------------------------
var
CHServer : DWORD;
RegisterComHookChain : TCHRegister;
InitDone : Boolean = false;

begin
 if not InitDone then begin
   InitDone := true;
   SHGetMallocResult := SHGetMalloc(IMalloc(pvSHGetMalloc));
   CoGetMallocResult := CoGetMalloc(1, IMalloc(pvCoGetMalloc));
   CHServer := GetModuleHandle(CHServerName);
   if CHServer <> 0 then begin
     RegisterComHookChain := GetProcAddress(CHServer, CHRegisterName);
     if @RegisterComHookChain <> nil then 
       RegisterComHookChain(@CTest0);
   end;
 end;
end.