.586P
.MODEL FLAT, STDCALL
UNICODE=0
INCLUDE WINDOWS.inc
INCLUDELIB KERNEL32
INCLUDELIB USER32
INCLUDELIB OLE32
INCLUDELIB SHELL32

INCLUDE ComHooks.inc

 Beep             PROTO :DWORD, :DWORD
 GetProcAddress   PROTO :DWORD, :DWORD
 GetModuleHandleA PROTO :DWORD
 GetModuleHandleW PROTO :DWORD
 IF UNICODE
   GetModuleHandle EQU <GetModuleHandleW>
 ELSE
   GetModuleHandle EQU <GetModuleHandleA>
 ENDIF

.CODE
;------------------------------------------------------------------
 ALIGN 4
 pvCoGetMalloc     DWORD 0
 CoGetMallocResult DWORD 0
 GetCoGetMalloc PROC ppv
   MOV      EDX, ppv
   MOV      ECX, pvCoGetMalloc
   MOV      EAX, CoGetMallocResult
   MOV      [EDX], ECX
   RET
 GetCoGetMalloc ENDP

 ALIGN 4
 pvSHGetMalloc DWORD 0
 SHGetMallocResult DWORD 0
 GetSHGetMalloc PROC ppv
   MOV      EDX, ppv
   MOV      ECX, pvSHGetMalloc
   MOV      EAX, SHGetMallocResult
   MOV      [EDX], ECX
   RET
 GetSHGetMalloc ENDP
;------------------------------------------------------------------
  ALIGN   4

;-----------
                         ;25336920-03F9-11CF-8FD0-00AA00686F13
  _CLSIDHTMLDoc40        CLSID <025336920H,03F9H,11CFH, <8FH,0D0H, 00,0AAH,00,68H,6FH,13H>>
  CLSIDHTMLDoc40         DWORD _CLSIDHTMLDoc40, TERM_CLSID
;-----------
  _IIDShellLinkA         IID \
                         <0000214EEH,0,0,<0C0H,0, 0,0,0,0,0,46H>>
  IIDShellLinkA          DWORD _IIDShellLinkA, TERM_IID
;-----------
  _IIDClassFactory       IID \
                         <000000001H,0,0,<0C0H,0, 0,0,0,0,0,46H>>  ;also in ole?.lib
  IIDClassFactory        DWORD _IIDClassFactory, TERM_IID
;-----------
  _IIDDispatch           IID \
                         <000020400H,0,0,<0C0H,0, 0,0,0,0,0,46H>>
  IIDDispatch            DWORD _IIDDispatch, TERM_IID
;-----------

  NewCoGetMallocMethods  METHOD_HOOK \
                         <04, NewCoGetMallocRealloc>,\
                         <TERM_METHOD_HOOK>
  NewSHGetMallocMethods  METHOD_HOOK \
                         <04, NewSHGetMallocRealloc>,\
                         <TERM_METHOD_HOOK>
  NewUnknownMethods      METHOD_HOOK \
                         <00, NewUnknownQueryInterface>,\
                         <TERM_METHOD_HOOK>
  NewClassFactoryMethods METHOD_HOOK \
                         <03, NewClassFactoryCreateInstance>,\
                         <TERM_METHOD_HOOK>
  NewDispatchMethods     METHOD_HOOK \
                         <06, NewDispatchInvoke>,\
                         <TERM_METHOD_HOOK>
  NewShellLinkAMethods   METHOD_HOOK \
                         <07, NewShellLinkASetDescription>,\
                         <20, NewShellLinkASetPath>,\
                         <TERM_METHOD_HOOK>

 BeginComHooks Test0
   COM_HOOK <CONST_INTERFACE, GetSHGetMalloc, NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES, 09, NewSHGetMallocMethods,  NULL>
   COM_HOOK <CONST_INTERFACE, GetCoGetMalloc, NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES, 09, NewCoGetMallocMethods,  NULL>
   COM_HOOK <CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES, 03, NewUnknownMethods,      NULL>
   COM_HOOK <CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, IIDClassFactory, NO_INTERFACES, 05, NewClassFactoryMethods, NULL>
   COM_HOOK <CLASS_INTERFACE, CLSIDHTMLDoc40, NO_CLASSES, IIDDispatch,     NO_INTERFACES, 07, NewDispatchMethods,     NULL>
   COM_HOOK <CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, IIDShellLinkA,   NO_INTERFACES, 21, NewShellLinkAMethods,   NULL>
 EndComHooks
;------------------------------------------------------------------

 NewUnknownQueryInterface PROC ReqPar1, ReqPar2, pCHInfo, This_, riid, ppv
   INVOKE  Beep, 100, 100

   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 3
   TEST    EAX, EAX
   JNE     Failed

;----test
   MOV     ECX, ppv
   MOV     EAX, pCHInfo
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).GetNumMethods, riid, [ECX]
   MOV     EAX, pCHInfo
   MOV     ECX, (CHINFO PTR [EAX]).OldMethod
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).GetMethodAddr, ECX
;----

   MOV     EAX, ppv
   MOV     ECX, This_
   CMP     [EAX], ECX
   JE      Done
   MOV     EAX, pCHInfo
   ASSUME  EAX: PTR CHINFO
   MOV     EDX, (CHINFO PTR [EAX]).CHApis
   LEA     ECX, (CHINFO PTR [EAX]).mCLSID
   INVOKE  (COM_HOOK_APIS PTR [EDX]).HookMethods, ECX, riid, ppv, [EAX].ComHookChain, ALL_COM_HOOKS
  Done:
   SUB     EAX, EAX
  Failed:
   RET
 NewUnknownQueryInterface ENDP

 NewCoGetMallocRealloc PROC ReqPar1, ReqPar2, pCHInfo, This_, pv, cb_
   INVOKE  Beep, 200, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 3
   RET
 NewCoGetMallocRealloc ENDP

 NewSHGetMallocRealloc PROC ReqPar1, ReqPar2, pCHInfo, This_, pv, cb_
   INVOKE  Beep, 300, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 3
   RET
 NewSHGetMallocRealloc ENDP

 NewClassFactoryCreateInstance PROC ReqPar1, ReqPar2, pCHInfo, This_, pUnkOuter, riid, ppv
   INVOKE  Beep, 400, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EDX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EDX]).CallOldMethod, ECX, 4
   TEST    EAX, EAX
   JNE     Failed_
   MOV     EAX, pCHInfo
   ASSUME  EAX: PTR CHINFO
   MOV     EDX, [EAX].CHApis
   LEA     ECX, [EAX].mCLSID
   INVOKE  (COM_HOOK_APIS PTR [EDX]).HookMethods, ECX, riid, ppv, [EAX].ComHookChain, ALL_COM_HOOKS
   SUB     EAX, EAX
  Failed_:
   RET
 NewClassFactoryCreateInstance ENDP

 NewDispatchInvoke PROC ReqPar1, ReqPar2, pCHInfo,\
          This_,dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr
   INVOKE  Beep, 500, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 9
   RET
 NewDispatchInvoke ENDP

 NewShellLinkASetDescription PROC ReqPar1, ReqPar2, pCHInfo, This_, pszName
   INVOKE  Beep, 600, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 2
   RET
 NewShellLinkASetDescription ENDP

 NewShellLinkASetPath PROC ReqPar1, ReqPar2, pCHInfo, This_, pszFile
   INVOKE  Beep, 700, 100
   MOV     EAX, pCHInfo
   LEA     ECX, This_
   MOV     EAX, (CHINFO PTR [EAX]).CHApis
   INVOKE  (COM_HOOK_APIS PTR [EAX]).CallOldMethod, ECX, 2
   RET
 NewShellLinkASetPath  ENDP
;------------------------------------------------------------------

IFNDEF CH_STATIC_LINKING
  CHServer             CHServerName
  RegisterComHookChain CHRegisterName
ENDIF

DllMain@12:
  MOV      AL, [ESP+8]
  CMP      AL, DLL_PROCESS_ATTACH
  JNE      Ignore

  PUSH     NULL
  INVOKE   SHGetMalloc, ESP
  POP      pvSHGetMalloc
  MOV      SHGetMallocResult, EAX
  PUSH     NULL
  INVOKE   CoGetMalloc, 1, ESP
  POP      pvCoGetMalloc
  MOV      CoGetMallocResult, EAX

IFDEF CH_STATIC_LINKING
  MOV      EAX, OFFSET RegisterComHookChain
ELSE
  INVOKE   GetModuleHandle, ADDR CHServer
  TEST     EAX, EAX
  JE       Failure
  INVOKE   GetProcAddress, EAX, ADDR RegisterComHookChain
  TEST     EAX, EAX
  JE       Failure
ENDIF
  INVOKE   (TCHRegister PTR EAX), ADDR Test0
 Ignore:
 Failure:
  RET      12
  ALIGN    4
;------------------------------------------------------------------
END DllMain@12